import 'package:f0ckapp/providers/theme_provider.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

import 'package:get/get.dart';

import 'package:f0ckapp/utils/appversion_util.dart';
import 'package:f0ckapp/services/api_service.dart';
import 'package:f0ckapp/screens/media_grid.dart';
import 'package:f0ckapp/screens/settings_screen.dart';
import 'package:f0ckapp/screens/detailview_screen.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  await SystemChrome.setPreferredOrientations([DeviceOrientation.portraitUp]);
  await AppVersion.init();
  final ThemeController themeController = Get.put(ThemeController());

  final api = ApiService();
  await api.fetchMedia();
  Get.put(api);

  runApp(
    GetMaterialApp(
      theme: themeController.currentTheme.value,
      initialRoute: '/',
      getPages: [
        GetPage(name: '/', page: () => MediaGrid()),
        GetPage(name: '/settings', page: () => SettingsPage()),
        GetPage(
          name: '/:itemId',
          page: () {
            int? test = int.tryParse(Get.parameters['itemId']!);
            if (test == null) {
              return Scaffold(body: Center(child: Text('oof')));
            }
            return DetailView(initialItemId: test);
          },
        ),
      ],
      unknownRoute: GetPage(
        name: '/notfound',
        page: () => Center(child: Text('oof')),
      ),
    ),
  );
}
